package jp.co.sds_corp.tool.check;

public class JavaChecker extends Checker
{
	String version;
	String major_ver;
	String minor_ver;

	@Override
	public int getCheckCount() {
		return 2;
	}

	@Override
	public boolean check() {
		fireProgressNotify(ProgressListener.Type.HOLD, "Javaの確認");
		clearError();
		boolean ret = true;
		if (!checkVersion()) {
			ret = false;
		}
		fireProgressNotify(ProgressListener.Type.FORWARD, "Javaの確認");
		if (!checkEnv()) {
			ret = false;
		}
		fireProgressNotify(ProgressListener.Type.FORWARD, "Javaの確認");
		return ret;
	}

	boolean checkVersion() {
		version = System.getProperty("java.version");
		boolean ret = checkVersion(version);
		return ret;
	}

	boolean checkVersion(String version) {
		int minor = -1;
		String[] arr = version.split("_");
		major_ver = null;
		minor_ver = null;
		if (arr.length == 1) {
			major_ver = arr[0];
		} else {
			major_ver = arr[0];
			minor_ver = arr[1];
			try {
				minor = Integer.valueOf(minor_ver).intValue();
			} catch (Exception ex) {
			}
		}
		if (major_ver.equals("1.6.0")) {
			if (minor < 10) {
				String msg = Message.formatMessage("90201", version);
				addError(msg);
				return false;
			}
			if (minor < 35) {
				String msg = Message.formatMessage("90203", version);
				addError(msg);
				return false;
			}
		}
		if (major_ver.equals("1.7.0")) {
			if (minor < 7) {
				String msg = Message.formatMessage("90203", version);
				addError(msg);
				return false;
			}
		}
		return true;
	}

	boolean checkEnv() {
		boolean ret = true;
		String var = System.getProperty("deployment.jpi.mode.new");
		if (var == null || !var.equals("true")) {
			ret = false;
			String msg = Message.getString("90202");
			addError(msg);
		}
		return ret;
	}

}
