package	jp.co.sds_corp.tool.http;

import	java.util.ArrayList;
import	java.util.HashMap;
import	java.util.List;
import	java.util.Map;

import	jp.co.sds_corp.util.config.IConfiguration;

public class RequestInfo
{
	String url;
	String method = "POST";
	boolean	keepAlive = true;
	boolean	followRedirects = true;
	Map<String,String> mapReq = new HashMap<String,String>();
	Map<String,String> mapHeader = new HashMap<String,String>();
	List<ResponseParser> listParser = new ArrayList<ResponseParser>();

	public static RequestInfo createInstance( IConfiguration config )
		throws Exception
	{
		RequestInfo info = new RequestInfo();

		String var;
		info.url = config.getAttributes().get( "url" );
		var = config.getAttributes().get( "method", null );
		if ( var != null && var.length() > 0 ) {
			info.method = var;
		}
		var = config.getAttributes().get( "keepAlive", null );
		if ( var != null && var.length() > 0 ) {
			info.keepAlive = Boolean.valueOf( var ).booleanValue();
		}
		var = config.getAttributes().get( "followRedirects", null );
		if ( var != null && var.length() > 0 ) {
			info.followRedirects = Boolean.valueOf( var ).booleanValue();
		}

		List<IConfiguration> list;
		list = config.listChild( "request" );
		for ( IConfiguration c : list ) {
			String key = c.getAttributes().get( "key" );
			String value = c.getAttributes().get( "value", "" );
			info.mapReq.put( key, value );
		}
		list = config.listChild( "header" );
		for ( IConfiguration c : list ) {
			String key = c.getAttributes().get( "key" );
			String value = c.getAttributes().get( "value", "" );
			info.mapHeader.put( key, value );
		}

		list = config.listChild( "response" );
		for ( IConfiguration c : list ) {
			ResponseParser parser = ResponseParser.createInstance( c );
			info.listParser.add( parser );
		}
		return info;
	}

	public String getUrl() {
		return url;
	}

	public String getMethod() {
		return method;
	}

	public boolean isKeepAlive() {
		return keepAlive;
	}

	public boolean isFollowRedirects() {
		return followRedirects;
	}

	public Map<String,String> mapHeader() {
		return mapHeader;
	}

	public Map<String,String> mapRequest() {
		return mapReq;
	}

	public List<ResponseParser> listParser() {
		return listParser;
	}

}
