package	jp.co.sds_corp.tool.http;

import	java.util.regex.Pattern;
import	java.util.regex.Matcher;

import jp.co.sds_corp.util.log.CmnLogFactory;
import	jp.co.sds_corp.util.log.CmnLogger;
import	jp.co.sds_corp.util.config.IConfiguration;

public class ResponseParser
{
	CmnLogger logger = CmnLogFactory.getInstance().getLogger(this);
	String name;
	String spattern;
	Pattern pattern;
	int	group;

	public static ResponseParser createInstance( IConfiguration config )
		throws Exception
	{
		ResponseParser parser = new ResponseParser();

		parser.name = config.getAttributes().get( "name" );
		parser.spattern = config.getAttributes().get( "pattern" );
		parser.pattern = Pattern.compile( parser.spattern );
		String var;
		var = config.getAttributes().get( "group", null );
		if ( var != null && var.length() > 0 ) {
			parser.group = Integer.valueOf( var ).intValue();
		}
		return parser;
	}

	public String getName() {
		return name;
	}

	public String parse( String response ) throws Exception {
		// logger.debug( "parse:" + response );
		if ( response == null || response.length() == 0 ) {
			return response;
		}
		Matcher matcher = pattern.matcher( response );
		if ( !matcher.find()) {
			return null;
		}
		String value = matcher.group( group );
		logger.debug( name + "=" + value );
		return value;
	}

}
