package	jp.co.sds_corp.tool.test;

import jp.co.sds_corp.util.config.IConfigurable;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;
import jp.co.sds_corp.tool.test.TestRunner;

public class SleepTester implements TestRunner, IConfigurable
{
	CmnLogger logger = CmnLogFactory.getInstance().getLogger(this);
	long time = 0;

	@Override
	public void init(IConfiguration config) throws Exception {
		String var;
		var = config.getAttributes().get( "time", null );
		if ( var != null && var.length() > 0 ) {
			time = Long.valueOf( var ).longValue();
		} else {
			logger.debug("time not set." + var);
		}
		logger.debug("loaded. time=" + time);
	}

	@Override
	public void startService() throws Exception {
	}

	@Override
	public void startThread() throws Exception {
	}

	@Override
	public void testCase( IConfiguration config, String param ) throws Exception {
		long time = this.time;
		try {
			time = Long.valueOf(param);
		} catch (Exception ex) {
		}
		if ( time > 0 ) {
			logger.debug("sleep " + time);
			Thread.sleep( time );
		} else {
			logger.debug("time not set.");
		}
	}

	@Override
	public void stopThread() throws Exception {
	}

	@Override
	public void stopService() throws Exception {
	}

	@Override
	public String toString() {
		String ret = super.toString();
		ret += " time=" + time;
		return ret;
	}

}
