package jp.co.sds_corp.tool.test;

import jp.co.sds_corp.test.BasicTestCase;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class CommandTest extends BasicTestCase
{
	CmnLogger logger = CmnLogFactory.getInstance().getLogger(this);
	TestCommand obj;

	public void setUp() throws Exception {
		super.setUp();
		logger.debug( "setUp" );
		obj = new TestCommand(new DummyRunner());
		//IConfiguration config = new DOMConfiguration( "target/test-classes/testcase.xml" );
		obj.init();
	}

	public void testTest1() throws Exception {
		logger.debug( "testTest1" );
		obj.test( "test 1,3-5,8" );
	}

	public void testTest2() throws Exception {
		logger.debug( "testTest2" );
		obj.test( "test 1,3-5,8" );
	}

	public void testTest3() throws Exception {
		logger.debug( "testTest3" );
		obj.test( "test 1,3-5,8 50" );
	}

	public void testTest4() throws Exception {
		logger.debug( "testTest4" );
		obj.test( "test 1,3-5,8 50 3" );
	}

	public void testSleep() throws Exception {
		logger.debug( "testSleep" );
		obj.test( "test 10" );
		obj.test( "test 10 200" );
	}

	public void testNop() throws Exception {
		logger.debug( "testNop" );
		obj.test( "test 12" );
	}

	public void testErr1() throws Exception {
		logger.debug( "testErr1" );
		try {
			obj.test( "ABC " );
			fail("no error");
		} catch (Exception ex) {
		}
	}

	public void testErr2() throws Exception {
		logger.debug( "testErr2" );
		obj = new TestCommand();
		obj.init();
		obj.command("test 0");
	}

	public void testStart() throws Exception {
		logger.debug( "testSart" );
		obj.startService();
		obj.startThread();
		obj.stopThread();
		obj.stopService();

		obj.command("start");
		obj.command("run");
		obj.command("list");
		obj.command("test 0");
		obj.command("set KEY=VAL");
		obj.command("show response");
		obj.command("show system");
		obj.command("show properties");
		obj.command("show memory");
		obj.command("show thread");
		obj.command("show stack");
		obj.command("show AAA");
		obj.command("history");
		obj.command("help");
		obj.command("!!");
		obj.command("!help ; !!");
		obj.command("!!");
		obj.command("ERR");
		obj.command("stop");
	}

}
